// =========================================================================
// $Source: /home/cvs/Taktuk2/NetworkCore/src/acom_fmtstream.h,v $
// (c) INRIA, projet APACHE, 2001
// Author: T. Gautier
//
//
// =========================================================================
#ifndef _ACOM_FORMAT_STREAM_H_
#define _ACOM_FORMAT_STREAM_H_

#include <inuk/acom_error.h>
#include <inuk/acom_stream.h>
#include <inuk/acom_format.h>

namespace ACOM_NET_NAMESPACE { 

// --------------------------------------------------------------------
/*
 * A StreamFormat permits to compile format in order to 
 * give representation as map to memory of an object
 */
class StreamFormat : public OStream {
public:

  StreamFormat( void* base, std::vector<Format::OffSetDataOut>* desc_i, std::vector<Format::OffSetDataOut>* desc_d ) 
   : OStream(0, 0), _base(base), _ia(desc_i), _da(desc_d)
  { }

  void write( const Format* fmt, Mode m, const void* data, size_t len );
  void write( const Format* fmt, const void* data, size_t len );

protected:
  void*                               _base;
  std::vector<Format::OffSetDataOut>* _ia;
  std::vector<Format::OffSetDataOut>* _da;
};

} // namespace 

#endif
