// =====================================================================
// $Source: /home/cvs/Taktuk2/NetworkCore/src/acom_gstream.h,v $
// (c) INRIA, projet APACHE, 2001
// Author: T. Gautier
//
//
//
// =====================================================================
#ifndef _ACOM_GSTREAM_H_
#define _ACOM_GSTREAM_H_

#include <inuk/acom_netconfig.h>
#include <inuk/acom_error.h>
#include <inuk/acom_format.h>
#include <inuk/acom_stream.h>
#include <vector>
#include <string>


namespace AC = ACOM_NET_NAMESPACE;


/* -----------------------------------
*/
inline AC::OStream& operator<< (AC::OStream& m, const bool& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<bool>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const char& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<char>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const unsigned char& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned char>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const short& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<short>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const unsigned short& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned short>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const int& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<int>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const unsigned int& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned int>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const long& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<long>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const unsigned long& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned long>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const long long& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<long long>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const unsigned long long& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned long long>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const float& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<float>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const double& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<double>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const long double& v )
{ m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<long double>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

template<class T>
inline AC::OStream& operator<< (AC::OStream& m, const std::vector<T>& v )
{ 
  size_t sz = v.size();
  m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<size_t>::format, &sz, 1); 
  m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<T>::format, (const T*)&v[0], sz); 
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}

inline AC::OStream& operator<< (AC::OStream& m, const std::string& v )
{
  size_t sz = v.size();
  m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<size_t>::format, &sz, 1);
  m.write( ACOM_NET_NAMESPACE::ACOMWrapperFormat<char>::format, (const char*)&v[0], sz);
#ifdef ACOM_TRACE_STREAM
  cout << "::WRITE=" << v << endl;
#endif
  return m;
}



/* -----------------------------------
*/
inline AC::IStream& operator>> (AC::IStream& m, bool& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<bool>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, char& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<char>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, unsigned char& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned char>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, short& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<short>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, unsigned short& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned short>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, int& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<int>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, unsigned int& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned int>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, long& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<long>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, unsigned long& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned long>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, long long& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<long long>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, unsigned long long& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<unsigned long long>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, float& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<float>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, double& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<double>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

inline AC::IStream& operator>> (AC::IStream& m, long double& v )
{ m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<long double>::format, &v, 1); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}

template<class T>
inline AC::IStream& operator>> (AC::IStream& m, std::vector<T>& v )
{ 
  size_t sz =0;
  m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<size_t>::format, &sz, 1); 
  v.resize(sz);
  m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<T>::format, (T*)&v[0], sz); 
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}


inline AC::IStream& operator>> (AC::IStream& m, std::string& v )
{
  size_t sz =0;
  m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<size_t>::format, &sz, 1);
  v.resize(sz);
  m.read( ACOM_NET_NAMESPACE::ACOMWrapperFormat<char>::format, (char*)&v[0], sz);
#ifdef ACOM_TRACE_STREAM
  cout << "::READ=" << v << endl;
#endif
  return m;
}


#endif
