// ==========================================================================
// $Source: /home/cvs/Taktuk2/Pthread/src/pth_system.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: J. Briat & T. Gautier
// $Id: pth_system.h,v 1.1.1.1 2004/06/29 13:32:12 martinc Exp $
//
// ==========================================================================

#ifndef _PTH_SYSTEM_H_ 
#define _PTH_SYSTEM_H_

/*!
\file  
\brief Pthread module initialisation  of Inuktitut0 INRIA.
\author  J. Briat T. Gautier 

This file is dedicated to initialization , commit and finalization of of
of the Posix thread module of Inuktitut0   INRIA.
 
 This part is environnement dependant and must be adapted as needed.

\sa PTH::Pth::initialize() PTH::Pth::commit() PTH::Pth::terminate()

\date 2001
*/

#include <inuk/pth_ns.h>
#include <inuk/pth_error.h>
#include <inuk/pth_dep.h>

extern "C"
{
//	#include <pthread.h>
//	#include "Win32pthread.h"
}
/////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////
#if defined(PTH_HAVE_NANOSLEEP)
extern "C" {
#include <time.h> // for nanosleep
}
#elif defined(PTH_HAVE_MICROSLEEP)
extern "C" {
#include <unistd.h> // for usleep
}
#elif defined(PTH_HAVE_SLEEP)
extern "C" {
#include <unistd.h> // for usleep
}
#endif
namespace PTH {

// -------------------------------------------------------------------------
// POSIX Thread package : static values
// -------------------------------------------------------------------------
/** 
\brief This part initializes all  static values for POSIX
threads, mutex etc .. 
*/
class Pth {
public :
/// initialize static value etc...   
static void initialize(int* ac=0, char***av=0)throw (PosixError);
///  Posix thread for Inuktitut0++ INRIA is up 
static void commit()throw (PosixError);
///  Posix thread for Inuktitut0++ INRIA is down 
static void terminate()throw (PosixError);
/// Copyright info about  Posix thread for Inuktitut0++ INRIA  
static const char* info();
/// Version for  Posix thread for Inuktitut0++ INRIA
static const char* version();
/// cooking info
static const char* gateau_chocolat();

};

} // -namespace

#endif // _PTH_SYSTEM_H_
