 // ==========================================================================
// $Source: /home/cvs/Taktuk2/Psocket/src/sock_server.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file for more information
// Author: J Briat T.Gautier
// Header file for Inuktitut/Psocket
//
//
//
// ==========================================================================
#ifndef __SOCK_SERVER_H_
#define __SOCK_SERVER_H_

#include <inuk/sock_basic.h>
#include <inuk/sock_client.h>

namespace SOCK {

class SocketServer: public Socket {
private:
  /**   Constructor
  */
  SocketServer(int fd)
   : Socket()
  { set_fd(fd); }

public:

  /**  Constructor
  */
  SocketServer()
   : Socket()
  {}

  /** bind socket to Localaddr.
  *  \return  zero if bind was successfull, else -1
  */
  int bind(const Address& Localaddr);

  /*! bind socket to _addr.
   *  \return  zero if bind was successfull, else -1
   */
  int bind();

  /** listen for connections on socket
   * \return zero on success, else -1
   */
  int listen(int backlog);//maybe in the accept????

  /** wait for incoming connection, return Socket object for client.
   *  Blocks until a client has connected
   *  \return socket object, connected to the computer that requested a
   *          connection
   */
  SocketClient& accept(const Address& Localaddr, SocketClient& sc);

  /** wait for incoming connection, return Socket object for client.
   *  Blocks until a client has connected
   *  \return socket object, connected to the computer that requested a
   *          connection
   */
  SocketClient& accept(SocketClient& sc );

private:
  int state; // bind done, listen done, etc...
};

} // namespace SOCK

#endif

