/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __DEBUGLOG_H
#define __DEBUGLOG_H

#ifndef LOGFILE
#define LOGFILE "/tmp/Taktuk"
#endif

#ifndef DEBUGLIST
#define DEBUGLIST "\" redirIO IOredir process post dojob getinfo setinfo steal scheduler info init taktuk_init taktuk_terminate spawner barrier topology_analyser taktukexec WARNING: PANIC: connector debuglog topo timeout prof ERROR SOCKET \""
//#define DEBUGLIST "\" ERROR dojob getinfo setinfo steal scheduler info init router process post taktuk_init taktuk_terminate redirIO spawner remote_call barrier output_service input_service topology_analyser localIOprocess am_call readall sendall taktukexec sendiov outchannel read_header WARNING: PANIC: envrsh connector IOredir input output debuglog topo readiov \""
//#define DEBUGLIST "\" init localIOprocess am_call readall redirIO sendall taktukexec sendiov outchannel read_header WARNING: PANIC: \""
//#define DEBUGLIST "\" WARNING: PANIC: tooloaded\""


#endif


#include <string>
#include <stdio.h>
#include <inuk/pth>
#include <sys/time.h>
#include <stdarg.h>

class debuglog
{
 public:
  debuglog();
  debuglog(std::string& logfile);
  debuglog(char* logfile);
  debuglog(std::string& logfile, std::string& debuglist);
  debuglog(char* logfile, char* debuglist);
  ~debuglog();
	inline  void log(char* name,char* format...){
#ifdef DEBUG
  if(strcmp(name,"")==0 || list.find(name,0)!=std::string::npos)
	{
		
		if(fd == NULL)
			open();
		if(fd!=NULL)
		{
			log_mutex.locknothrow();
			va_list ap;
			if (strcmp(name,"")!=0)
				fprintf(fd,"%s <nid:%d>:",name,rank);
			va_start(ap,format);
	  
			if(fd!=NULL)
				vfprintf(fd,format,ap);
      
			va_end(ap);
			fflush(fd);
			log_mutex.unlocknothrow();
		}
	}
#endif
}
  void Xmem(void* begin, int size);
  void setrank(int r);
 private:
  int rank;
  void open();
  char pid[8];
  std::string filename;
  std::string list;
  FILE* fd;
  PTH::Mutex log_mutex;
};

extern debuglog dbg;

class Profile
{
  public:
	Profile(){
		Bok=Eok=false;
		begin.tv_sec=0;
		begin.tv_usec=0;
		end.tv_sec=0;
		end.tv_usec=0;
		
//		fctname=fct;
//		logger=log;
	}
	~Profile(){}
	void B(){
		gettimeofday(&begin,NULL);
		Bok=true;
	}
	void E(){
		gettimeofday(&end,NULL);
		Eok=true;
	}
	void erase(){
		Bok=Eok=false;
    begin.tv_sec=0;
    begin.tv_usec=0;
    end.tv_sec=0;
    end.tv_usec=0;	
	}
	void get_B(struct timeval * time)
	{
		if(time!=NULL)
		{
			time->tv_sec=begin.tv_sec;
			time->tv_usec=begin.tv_usec;
		}
	}
	void get_E(struct timeval * time)
	{
		if(time!=NULL)
		{
			time->tv_sec=end.tv_sec;
			time->tv_usec=end.tv_usec;
		}
	}
	double Time_sec(){
		if(Bok&&Eok)
			return ((double)( end.tv_sec - begin.tv_sec)+0.000001*(double)(end.tv_usec - begin.tv_usec));
		else
		{
			
			return 0.0;
		}
//		logger->log("prof"," [%s] %f sec\n",fctname,((double)( end.tv_sec - begin.tv_sec)+0.000001*(double)(end.tv_usec - begin.tv_usec)));
	}
	bool BOK(){return Bok;}
	bool EOK(){return Eok;}
  private:
//	debuglog* logger;
//	char* fctname;
  bool Bok;
	bool Eok;
	struct timeval begin;
	struct timeval end;
};


#endif /*__DEBUGLOG_H*/
