#ifndef MPUT_FILE_READER_H
#define MPUT_FILE_READER_H

#include "mput.h"

extern int current_read_buffer;
extern int current_read_position;
extern int last_read_buffer;


/**
Initialise le file_reader
*/
void init_file_reader();

/**
fonction (generalement lancee comme thread)
qui lit la file de fichier passes en argument du thread
(struct files) en ignorant le dernier

Argument : pointeur sur la structure "struct files"
*/
void * file_reader(void *input_files);


/**
Traite le fichier passe en argument

Argument : nom du fichier
*/
int file_read_absolute(char * file_name);

/**
Traite le fichier decoupe en base/directory/filename passse en argument

Parametres : nom du fichier
             repertoire du fichier tel qu'il sera ecrit dans le buffer
	     base du repertoire qui sera ignore lors de la recopie
*/
int file_read_relative(const char * file_name, const char * directory, const char * base);

/**
Echange le buffer de lecture
*/
void switch_read_buffer();

/**
Retour ne laposition du premier caractere du nom de fichier :
path/filename[* /]
     ^

Argument : path du fichier

Valeur de retour : rang du premier caractere dans la chaine
*/
int get_file_name_start(const char * file_name);

/**
Ecrit la taille du nom de fichier dans le buffer

Parametre : taille du nom de fichier avec le caractere d'arret null
*/
void set_file_name_size(uint32_t file_name_size);

/**
Ecrit le nom du fichier file_name concatene avec directory dans le buffer
en ecrivant d'abord la taille du fichier

Parametres : nom du fhichier
             nom du repertoire concatene avec le nom du fichier
*/
void set_file_name(const char * file_name, const char * directory);

/**
Ecrit les stats d'un fichier dans le buffer

Parametre : statistiques du fichier
*/
void set_stat(struct stat * file_stat);

/**
Lit les donnees du fichier sur le disque et les ecris dans le buffer

Parametres : fichier d'entre
             statistiques du fichier
*/
void read_data(int input, struct stat * file_stat);

#endif
