#ifndef MPUT_WRAPPERS_H
#define MPUT_WRAPPERS_H

#include "mput.h"
#include <dirent.h>

/**
Affiche un message d'erreur contenant la chaine message et la traduction du
numero d'erreur error_number
*/
void error_report(const char * message, int error_number);

void *Malloc(size_t size);

FILE *Fopen(const char *path, const char *mode);

int Creat(const char *pathname, mode_t mode);

int Stat(const char *pathname, struct stat *buf);

int Fclose(FILE *stream);

DIR *Opendir(const char *name);

int Closedir(DIR *dir);

const char *Inet_ntop(int af, const void *src, char *dst, socklen_t cnt);

int Inet_pton(int af, const char *src, void *dst);

int Socket(int domain, int type, int protocol);

int Connect(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen);

int Bind(int sockfd, struct sockaddr *my_addr, socklen_t addrlen);

int Listen(int s, int backlog);

int Accept(int s, struct sockaddr *addr, socklen_t *addrlen);

int Close(int fd);

int Getsockname(int s, struct sockaddr *name, socklen_t *namelen);
 
ssize_t Read(int fd, void *buf, size_t count);

ssize_t Write(int fd, const void *buf, size_t count);

int Pthread_mutex_init(pthread_mutex_t  *mptr, const pthread_mutexattr_t *maptr);

int Pthread_mutex_lock(pthread_mutex_t *mptr);

int Pthread_mutex_unlock(pthread_mutex_t *mptr);

int Pthread_cond_init(pthread_cond_t *cptr, pthread_condattr_t *aptr);

int Pthread_cond_wait(pthread_cond_t *cptr,pthread_mutex_t *mptr);

int Pthread_cond_signal(pthread_cond_t *cptr);

int Pthread_cond_broadcast(pthread_cond_t *cptr);

int Pthread_create(pthread_t *tid, const pthread_attr_t *attr, void *(*start_routine)(void *), void *arg);

int Pthread_join(pthread_t tid, void **status);

int Readlink(const char * path, char *buf, size_t bufsiz);

int Symlink(const char *oldpath, const char *newpath);

int Unlink(const char * path);
#endif
