/*
 * The contents of this file are subject to the Dyade Public License,
 * as defined by the file DYADE_PUBLIC_LICENSE.TXT
 *
 * You may not use this file except in compliance with the License. You may
 * obtain a copy of the License on the Dyade web site (www.dyade.fr).
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 * 
 * 
 *
 * The Initial Developer of the Original Code is Dyade. The Original Code and
 * portions created by Dyade are Copyright Bull and Copyright INRIA.
 * All Rights Reserved.
 */
/* Copyright (c) 1997 by Groupe Bull. Read the COPYRIGHT file. */
/* $Id: */
/* Author: Cyrille.Martin@imag.fr */

/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __TOPOLOGY_ANALYSER_H
#define __TOPOLOGY_ANALYSER_H


#include <string>
#include <inuk/taktuk/topology.h>

class host;

class topology_analyser
{
 public:
  topology_analyser(){}
  ~topology_analyser(){}
	/** get initialize a topology with argc and argv
	 * @param argc count options in argv it's modified by this call all lib
	 * optons are removed
	 * @param argv NULL terminated array of arguments all Lib's arguments are
	 * removed
	 * @param topology 
     * @param new_arg_parsing use new inuk arg specif ( -- taktuk -c fork ... )
	 * This function initialize the Topology object with argc, argv or File
	 * - hostsmap is correctly fromated after this call
	 * - topology field like 
	 * 		- arity
	 * 		- steal_num
	 * 		- verbose
	 * 		- perf
	 * 		- cloexec
	 * 		- etc ...
	 * @return error code :
	 * 	- 0 all is good
	 * 	- -1 parse error
	 * 	- -2 environement variable not readable
	 */ 
  int get(int* argc, char** argv[],topology* topo, bool new_arg_specif);
	
 private:
	
  /** options_parser parse argv to intialize some field of topology
	 * @param argc count options
	 * @param argv NULL terminated array of char* argments
	 * @param topology topology to initialize
	 * @return -1 when parse error 0 if all is good
	 */ 
	int options_parser(int* argc, char** argv[], topology* topo);
	
	/** args_parser complete topology initialization and remove lib option of
	 * argv update also argc
	 * @param argc count options
	 * @param argv NULL terminated array of char* argments
	 * @param topology topology to initialize
	 */ 
  void args_parser(int* argc, char** argv[], topology* topo);

	/** addnodecmd add one host descrition in a string
	 * @param const host* the host which must be added in cmd
	 * @param const string reference the string where host is added
	 */ 
	void addnodecmd(const topology::host* h, std::string& cmd);

	/** get_childs_cmds compute hostsmap to reduce it to childs description only
	 * tabs. All other hosts specified are added in taktukargs fields of childs
	 * and are remove of the hostsmap
	 * After this call hostsmap size is equal to arity
	 * @param topology
	 */ 
  void get_childs_cmds(topology* topo);

	/** get_user_env get environement variable to get user login
	 * @param topology
	 * @return int error code -2 if no variable defined or 1 if all is good
	 */ 
  int get_user_env(topology* topo);

	// internal variables
  std::string prog_name;  
  std::string taktuk_args;
  bool new_arg_spec;
};

#endif /* __TOPOLOGY_ANALYSER_H*/
